abstract Query = QueryBase ** {

cat
  Place ;  -- any way to identify a place: name, click, or indexical "here"

fun
  GoFromTo : Place -> Place -> Input ; -- user input "want to go from a to b"
  GoToFrom : Place -> Place -> Input ; -- user input "want to go to a from b"
  ComeFrom : Place -> Input ;          -- user input "want to come from a" 
                                       -- (to where I am now)
  GoTo     : Place -> Input ;          -- user input "want to go to a" 
                                       -- (from where I am now)
  PClick   : Click -> Place ;          -- click associated with a "here"
  PHere    : Place ;                   -- indexical "here", without a click
  PNamed   : String -> Place ;         -- any place name

}