abstract Click = QueryBase ** {

cat
  StopList ; -- a list of stop names

fun
  -- click giving x and y coordinates
  CCoord   : Int -> Int -> Click ;

  -- a click represented by a set of place names
  CStops : StopList -> Click ;

  -- the empty stop list
  NoStop : StopList ;
  
  -- a single stop
  OneStop : String -> StopList ;

  -- More than one stop
  -- the second argument should be a ManyStops or a OneStop,
  -- i.e. not a NoStop
  ManyStops : String -> StopList -> StopList ;

}